﻿using System;
using tom;
using tstopc_cs;
namespace tstopc_cs
{
    class Program
    {
        [System.Runtime.InteropServices.DllImport("msvcrt.dll", EntryPoint = "_getch")]
        public static extern int _getch();
        [System.Runtime.InteropServices.DllImport("msvcrt.dll", EntryPoint = "_kbhit")]
        public static extern int _kbhit();
        
        
        public static long time_t()
        {
            DateTime t1 = new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc);
            long t = (DateTime.UtcNow.Ticks - t1.Ticks) / 10000000;
            return t;
        }
        public const string g_sClsID = "{F4936E52-296A-4ED9-937A-D8A643D6EB33}";// CLSID 用GUID工具产生的Registry Format
        public const string g_sVendor = "tom";									// 提供商,比如"tom"
        public const string g_sDrivername = "opctst_cs";						// 驱动名,比如"rdb4opcda"
        public const string g_sVersion = "1";									// 版本名,比如"1" 
        public const string g_sOpcServerDes = "opc server dll test use c#";		// OPC Server描述 ，<128字符

        static void Main(string[] args)
        {
            int nret;
            if (args.Length == 1)
            {
                if (string.Compare(args[0], "reg", true) == 0 || 
                    string.Compare(args[0], "-reg", true) == 0 || 
                    string.Compare(args[0], "/reg", true) == 0)//安装注册

                { 
                    nret = Opcsrv.opcsvr_reg(g_sClsID, g_sVendor, g_sDrivername, g_sVersion, g_sOpcServerDes, 0);
                    if (nret != Opcsrv.OE_OK)
                        Console.Write("reg error {0}\n", nret);
                    else
                        Console.Write("reg success\n");
                    Console.Write("any key to exit...\n");
                    _getch();
                    return;
                }
                else if (string.Compare(args[0], "unreg", true) == 0 || 
                    string.Compare(args[0], "-unreg", true) == 0 ||
                    string.Compare(args[0], "/unreg", true) == 0)//卸载
                { 
                    nret = Opcsrv.opcsvr_unreg(g_sClsID, g_sVendor, g_sDrivername, g_sVersion, g_sOpcServerDes);
                    if (nret != Opcsrv.OE_OK)
                        Console.Write("unreg error {0}\n", nret);
                    else
                        Console.Write("unreg success\n");
                    Console.Write("any key to exit...\n");
                    _getch();
                    return;
                }
            }
            Console.Write("press 'Q' to quit...\n");

            CTstdata tstdata = new CTstdata();
            tstdata.AddTag();//添加测试标签
            nret = Opcsrv.opcsrv_start(g_sClsID, g_sVendor, g_sDrivername, g_sVersion, g_sOpcServerDes, tstdata.SetItemVal, (IntPtr)null, 0);//启动
            if (nret != Opcsrv.OE_OK)
            {
                Console.Write("opcsrv_start error {0}\n", nret);
                Console.Write("any key to exit...\n");
                _getch();
                return;
            }

            int c;
            long told = 0, t = 0;
            tstdata.SimuVal(t);
            while (true)
            {
                if (_kbhit() != 0)
                {
                    c = _getch();
                    if (c == 'q' || c == 'Q')
                        break;
                }
                System.Threading.Thread.Sleep(100);
                t = time_t();
                if (told != t) //每秒模拟一次数据
                {
                    tstdata.SimuVal(t);
                    told = t;
                }
            }
            Opcsrv.opcsrv_stop();//停止
            return;
        }
    }
}
