﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using tom;
using tstopc_cs;
namespace tstopc_csw
{
    static class Program
    {
        public const string g_sClsID = "{D649143F-36FD-44C2-96C6-E56E43077944}";// CLSID 用GUID工具产生的Registry Format
        public const string g_sVendor = "tom";									// 提供商,比如"tom"
        public const string g_sDrivername = "opctst_csw";						// 驱动名,比如"rdb4opcda"
        public const string g_sVersion = "1";									// 版本名,比如"1" 
        public const string g_sOpcServerDes = "opc server dll test use c# Form";		// OPC Server描述 ，<128字符
        /// <summary>
        /// 应用程序的主入口点。
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            int nret;
            string smsg;
            if (args.Length == 1)
            {
                if (string.Compare(args[0], "reg", true) == 0 || 
                    string.Compare(args[0], "-reg", true) == 0 || 
                    string.Compare(args[0], "/reg", true) == 0)//安装注册
                {
                    nret = Opcsrv.opcsvr_reg(g_sClsID, g_sVendor, g_sDrivername, g_sVersion, g_sOpcServerDes, 0);
                    if (nret != Opcsrv.OE_OK)
                    {
                        smsg = string.Format("reg error {0}", nret);
                        MessageBox.Show(smsg, "opctst_csw");
                    }
                    else
                        MessageBox.Show("reg success", "opctst_csw");
                    return;
                }
                else if (string.Compare(args[0], "unreg", true) == 0 || 
                    string.Compare(args[0], "-unreg", true) == 0 || //卸载
                    string.Compare(args[0], "/unreg", true) == 0)
                {
                    nret = Opcsrv.opcsvr_unreg(g_sClsID, g_sVendor, g_sDrivername, g_sVersion, g_sOpcServerDes);
                    if (nret != Opcsrv.OE_OK)
                     {
                        smsg = string.Format("unreg error {0}", nret);
                        MessageBox.Show(smsg, "opctst_csw");
                    }
                    else
                        MessageBox.Show("unreg success", "opctst_csw");
                    return;
                }
            }

            CTstdata tstdata = new CTstdata();
            tstdata.AddTag();//添加测试标签
            nret = Opcsrv.opcsrv_start(g_sClsID, g_sVendor, g_sDrivername, g_sVersion, g_sOpcServerDes, tstdata.SetItemVal, (IntPtr)null, 0);//启动
            if (nret != Opcsrv.OE_OK)
            {
                smsg = string.Format("opcsrv_star error {0}", nret);
                MessageBox.Show(smsg, "opctst_csw");
                return;
            }
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new mainForm(ref tstdata));
            Opcsrv.opcsrv_stop();
        }
    }
}
