﻿/*! 
	\file opcsrv_da.cs
	\brief OPC Server SDK for C#
 
	OPC Server SDK for C#  
  
	\author 重庆唐码软件有限公司
	\version 3.0
	*/
namespace tom
{    
    [System.Runtime.InteropServices.UnmanagedFunctionPointerAttribute(System.Runtime.InteropServices.CallingConvention.StdCall)]
    public delegate bool cb_SetItemVal(
        [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] 
        string sTagName, 
        ref object pval, 
        ushort wqa, 
        long filetime, 
        System.IntPtr pCallBackArg
        );

    public class Opcsrv
    {
        public const int ODT_VOID = 0;
        public const int ODT_I8 = 1;
        public const int ODT_U8 = 2;
        public const int ODT_I16 = 3;
        public const int ODT_U16 = 4;
        public const int ODT_I32 = 5;
        public const int ODT_U32 = 6;
        public const int ODT_I64 = 7;
        public const int ODT_U64 = 8;
        public const int ODT_F32 = 9;
        public const int ODT_F64 = 10;
        public const int ODT_STR = 11;
        public const int ODT_BLOB = 12;
        public const int ODT_BOOL = 13;

        public const int OTEM_NOWRITE = 0;
        public const int OTEM_WRITE = 1;

        public const int OE_OK = 0;
        public const int OE_ERR = 1;
        public const int OE_ERRARG = 2;
        public const int OE_OUTMEM = 3;
        public const int OE_CLSID = 4;
        public const int OE_ERRCOM = 5;
        public const int OE_INITCOM = 6;
        public const int OE_NOITEM = 10;
        public const int OE_ERRTYPE = 11;
        public const int OE_ERRDATA = 12;
        public const int OE_ERRTIME = 13;
        public const int OE_ERRQA = 14;
        public const int OE_NODATA = 15;
        public const int OE_RUNING = 16;
        public const int OE_NOTRUN = 17;

        public const ushort OPC_QUALITY_MASK = 0xc0;
        public const ushort OPC_STATUS_MASK = 0xfc;
        public const ushort OPC_LIMIT_MASK = 0x3;
        public const ushort OPC_QUALITY_BAD = 0;		// 坏质量，常用
        public const ushort OPC_QUALITY_UNCERTAIN = 0x40;
        public const ushort OPC_QUALITY_GOOD = 0xc0;	// 好质量，常用
        public const ushort OPC_QUALITY_CONFIG_ERROR = 0x4;
        public const ushort OPC_QUALITY_NOT_CONNECTED = 0x8;
        public const ushort OPC_QUALITY_DEVICE_FAILURE = 0xc;	// 设备错误,坏质量细分
        public const ushort OPC_QUALITY_SENSOR_FAILURE = 0x10;	// 传感器错误,坏质量细分
        public const ushort OPC_QUALITY_LAST_KNOWN = 0x14;
        public const ushort OPC_QUALITY_COMM_FAILURE = 0x18;
        public const ushort OPC_QUALITY_OUT_OF_SERVICE = 0x1c;
        public const ushort OPC_QUALITY_WAITING_FOR_INITIAL_DATA = 0x20;
        public const ushort OPC_QUALITY_LAST_USABLE = 0x44;
        public const ushort OPC_QUALITY_SENSOR_CAL = 0x50;
        public const ushort OPC_QUALITY_EGU_EXCEEDED = 0x54;
        public const ushort OPC_QUALITY_SUB_NORMAL = 0x58;
        public const ushort OPC_QUALITY_LOCAL_OVERRIDE = 0xd8;
        public const ushort OPC_LIMIT_OK = 0;
        public const ushort OPC_LIMIT_LOW = 0x1;
        public const ushort OPC_LIMIT_HIGH = 0x2;
        public const ushort OPC_LIMIT_CONST = 0x3;
        
        [System.Runtime.InteropServices.DllImportAttribute("opcsrv_da.dll", EntryPoint = "opcsvr_reg", CallingConvention = System.Runtime.InteropServices.CallingConvention.StdCall)]
        public static extern int opcsvr_reg(
            [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string sClsID,
            [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string sVendor, 
            [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string sDrivername, 
            [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string sVersion, 
            [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string sOpcServerDes,
            int AsService
            );

        [System.Runtime.InteropServices.DllImportAttribute("opcsrv_da.dll", EntryPoint = "opcsvr_unreg", CallingConvention = System.Runtime.InteropServices.CallingConvention.StdCall)]
        public static extern int opcsvr_unreg(
            [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string sClsID, 
            [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string sVendor, 
            [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string sDrivername,
            [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string sVersion,
            [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string sOpcServerDes
            );


        [System.Runtime.InteropServices.DllImportAttribute("opcsrv_da.dll", EntryPoint = "opcsrv_addtag", CallingConvention = System.Runtime.InteropServices.CallingConvention.StdCall)]
        public static extern int opcsrv_addtag(
            [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string sName, 
            [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string sDes, 
            [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string sUnit, 
            int nType, 
            int nWriteable
            );

        [System.Runtime.InteropServices.DllImportAttribute("opcsrv_da.dll", EntryPoint = "opcsrv_start", CallingConvention = System.Runtime.InteropServices.CallingConvention.StdCall)]
        public static extern int opcsrv_start(
            [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string sClsID, 
            [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string sVendor, 
            [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string sDrivername,
            [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string sVersion,
            [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string sOpcServerDes,
            cb_SetItemVal pfcbSetTagVal, 
            System.IntPtr pcbSetTagValArg, 
            int LockServer
            );

        [System.Runtime.InteropServices.DllImportAttribute("opcsrv_da.dll", EntryPoint = "opcsrv_stop", CallingConvention = System.Runtime.InteropServices.CallingConvention.StdCall)]
        public static extern int opcsrv_stop();


        [System.Runtime.InteropServices.DllImportAttribute("opcsrv_da.dll", EntryPoint = "opcsrv_setval", CallingConvention = System.Runtime.InteropServices.CallingConvention.StdCall)]
        public static extern int opcsrv_setval(
            [System.Runtime.InteropServices.InAttribute()] [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.LPStr)] string sTagname,
            ref object pval, 
            ushort wqa, 
            long filetime);        
    }   
}
