#include "win_sys.h"
#include <stdlib.h>
#include <OAIdl.h>
#include "ntservice/ntservice.h"


#include "opcsrv_da/opcsrv_da.h"
#pragma comment(lib, "opcsrv_da/opcsrv_da.lib")


const char* g_sClsID = "{6AFAD11E-E1D3-4C86-83B7-216407D17C65}";// CLSID GUID߲Registry Format
const char* g_sVendor = "tom";									// ṩ,"tom"
const char* g_sDrivername = "tstopc_srv";						// ,"rdb4opcda"
const char* g_sVersion = "1";									// 汾,"1" 
const char*	g_sOpcServerDes = "tstopc_srv";		                // OPC Server <128ַ,Ą̊́ͬʱҲǷ

#include "tstdata.h" 

class COpcSrv
{
public:
    COpcSrv()
    {
        _lkill = 0;
        _lrun = 0;
        _hwait = ::CreateEventA(NULL,false, false, NULL);
    }
    ~COpcSrv()
    {
        if (_hwait != NULL)        
            ::CloseHandle(_hwait);
    }
private:
    long    _lkill,_lrun;
    HANDLE  _hwait;
    CTstData _tstdata;
    
    static void ThreadProcess(void* pargs)
    {       
        COpcSrv* pt = (COpcSrv*)pargs;
        pt->DoRun();
    }
    void DoRun()
    {
        time_t told = 0, t;
        InterlockedExchange(&_lkill, 0);
        InterlockedExchange(&_lrun, 1);                
        while (!InterlockedExchangeAdd(&_lkill, 0))
        {
            WaitForSingleObject(_hwait, 100);
            t = ::time(NULL);
            if (told != t) //ÿģһ
            {
                _tstdata.SimuVal(t);
                told = t;
            }
        }
        InterlockedExchange(&_lkill,0);
        InterlockedExchange(&_lrun, 0);
    }
public:
    bool Start()
    {
        if (InterlockedExchangeAdd(&_lrun, 0))
            return true;
        _tstdata.AddTag();//ӲԱǩ
        int nret = opcsrv_start(g_sClsID, g_sVendor, g_sDrivername, g_sVersion, g_sOpcServerDes, _tstdata.SetItemVal, NULL, true);//OPC
        if (nret != OE_OK)
            return false;
        _beginthread(ThreadProcess, 0, this);
        return true;
    }
    void Stop()
    {
        InterlockedExchange(&_lkill, 1);
        while (InterlockedExchangeAdd(&_lrun, 0))
            Sleep(100);
    }
};

class COpcService : public CNtService
{
public:
protected:
    //ɹûRun
    virtual void Run()
    {
        COpcSrv* psvr = new COpcSrv();
        if (!psvr)
            return;
        if (!psvr->Start())
        {
            psvr->Stop();
            delete psvr;
            return;
        }
        CNtService::Run();
        psvr->Stop();
        delete psvr;
    };
public:
    //ɹûDebug
    virtual void Debug()
    {
        COpcSrv* psvr = new COpcSrv();
        if (!psvr)
            return;
        if (!psvr->Start())
        {
            psvr->Stop();
            delete psvr;
            return;
        }
        CNtService::Debug();
        psvr->Stop();
        delete psvr;
    };
}_opcservice;


CNtService* CNtService::_pobj = &_opcservice;

LPCTSTR FindOneOf(LPCTSTR p1, LPCTSTR p2)
{
    while (p1 != NULL && *p1 != NULL)
    {
        LPCTSTR p = p2;
        while (p != NULL && *p != NULL)
        {
            if (*p1 == *p)
                return CharNext(p1);
            p = CharNext(p);
        }
        p1 = CharNext(p1);
    }
    return NULL;
}

void ShowMsg()
{
    MessageBox(NULL, _T("    ҪװΪ̨,ԱȨдڰװж\n tstopc_srv -install\n tstopc_srv -uninstall\n\n ˵!\n\n ޹˾Copyright(C) 2009-2016"),
        _T("tstopc_srv"), MB_OK);
}


int APIENTRY _tWinMain(HINSTANCE hInstance,
    HINSTANCE hPrevInstance,
    LPTSTR     lpCmdLine,
    int       nCmdShow)
{
    _opcservice.Init(_T("tstopc_srv"), _T("tstopc_srv"), _T("OPC Server SDK ̨Գ޹˾"));
    TCHAR szTokens[] = _T("-/");
    LPCTSTR lpszToken = FindOneOf(lpCmdLine, szTokens);

    if (lpszToken == NULL)
    {
        ShowMsg();
        return 0;
    }
    else
    {
        if (!lstrcmpi(lpszToken, _T("uninstall")))
        {
            if (OE_OK != opcsvr_unreg(g_sClsID, g_sVendor, g_sDrivername, g_sVersion, g_sOpcServerDes))
                MessageBox(NULL, _T("жOPC DCOM÷ʧ,ǷйԱȨ!"), _T("tstopc_srv"), MB_OK);            
            _opcservice.UnregisterServer();//жط
            return 0;
        }
        else if (!lstrcmpi(lpszToken, _T("install")))
        {
            if (!_opcservice.RegisterServer())//Ȱװ
            {
                MessageBox(NULL,_T("װʧ,ǷйԱȨ!"),_T("tstopc_srv"), MB_OK);
                return 0;
            }
            if (OE_OK != opcsvr_reg(g_sClsID, g_sVendor, g_sDrivername, g_sVersion, g_sOpcServerDes, 1))//ٰװCOM/DCOM,עΪservice
            {
                _opcservice.UnregisterServer();//жظղŰװķ
                MessageBox(NULL, _T("װOPC DCOM÷ʧ,ǷйԱȨ!"), _T("tstopc_srv"), MB_OK);
                return 0;
            }           
            return 0;
        }
        else if (!lstrcmpi(lpszToken, _T("debug")))
        {
            _opcservice.Debug();
            return 0;
        }

        else if (!lstrcmpi(lpszToken, _T("service")) || !lstrcmpi(lpszToken, _T("Embedding")))
        {
            _opcservice.Start();
            return 0;
        }
        else
            ShowMsg();
    }
    return 0;
}

